## uos-ai 2.11.501

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(uos-ai VERSION 0.1 LANGUAGES CXX)
add_compile_definitions(APP_VERSION="${APP_VERSION}")

# 全局配置
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -fPIC")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all -fPIC")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

# generate qm files
if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
    execute_process(COMMAND bash "${CMAKE_SOURCE_DIR}/translate_generation.sh" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# 库目录
set(LIB_PLATFORM_DIR "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}")
add_definitions(-DLIB_PLATFORM_DIR="${LIB_PLATFORM_DIR}")

# 插件
set(EXTERNAL_LLM_DIR "${LIB_PLATFORM_DIR}/uos-ai-assistant/llm")

# 获取系统版本
if (NOT DEFINED BUILD_OS_VERSION OR BUILD_OS_VERSION STREQUAL "")
    # 读取文件并提取Version值
    file(STRINGS "/etc/deepin-version" FILE_CONTENTS REGEX "^Version=")

    # 遍历文件内容，查找Version行
    foreach(LINE ${FILE_CONTENTS})
        # 检查是否是Version行
        if(LINE MATCHES "Version=([0-9]+)")
            # 提取版本号
            set(BUILD_OS_VERSION "${CMAKE_MATCH_1}")
        endif()
    endforeach()

    message("Get BUILD_OS_VERSION from deepin-version ${BUILD_OS_VERSION}")
else()
    message("catch BUILD_OS_VERSION ${BUILD_OS_VERSION}")
endif()

# Qt
if (${BUILD_OS_VERSION} MATCHES "25")
    find_package(QT NAMES Qt6)
else()
    find_package(QT NAMES Qt5)
endif()

# 配置选项
option(ENABLE_AGENT_PLUGIN "Enable Agent Plugin" ON)
option(ENABLE_MODEL_PLUGINS "Enable Model Plugins" OFF)
option(ENABLE_ASSISTANT "Enable AI Assistant" ON)
option(ENABLE_PERSONAL_KNOWLEDGE_ASSISTANT "Enable Personal Knowledge Assistant" OFF)
option(ENABLE_AI_BAR "Enable AI Bar" OFF)
option(ENABLE_TRAY_PLUGIN "Build Tray Plugin" ON)
option(ENABLE_MCP "Enable MCP Server" ON)

# 模型插件
option(ENABLE_MODEL_FYDN "Enable FYDN Plugin" OFF)
option(ENABLE_MODEL_PPT "Enable PPT Plugin" OFF)
option(ENABLE_MODEL_POSTER "Enable POSTER Plugin" OFF)
option(ENABLE_MODEL_RPA "Enable RPA Plugin" OFF)
option(ENABLE_MODEL_ZTBBD "Enable ZTBBD Plugin" OFF)
option(ENABLE_MODEL_XXZSK "Enable XXZSK Plugin" OFF)
option(ENABLE_MODEL_YZSBS "Enable YZSBS Plugin" OFF)
option(ENABLE_MODEL_TZDL "Enable TZDL Plugin" OFF)

# 系统判断
if (${BUILD_OS_VERSION} MATCHES "25")
    message("COMPILE ON v25")

    set(COMPILE_ON_V25 TRUE)
    add_definitions(-DCOMPILE_ON_V25)

    add_definitions(-DCOMPILE_ON_V23)
    set(COMPILE_ON_V23 TRUE)

    #先默认打开ppt助手
#    set(ENABLE_MODEL_PPT ON)
#    set(ENABLE_MODEL_POSTER ON)
    set(ENABLE_AI_BAR ON)

    if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64|aarch64")
        set(ENABLE_ASSISTANT OFF)
        set(ENABLE_MCP OFF)
#    else()
#        set(ENABLE_MODEL_RPA ON)
    endif()
    message("SYSTEM PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} ${ENABLE_ASSISTANT}")
elseif (${BUILD_OS_VERSION} MATCHES "23")
    add_definitions(-DCOMPILE_ON_V23)
    set(COMPILE_ON_V23 TRUE)
    message("COMPILE ON v23")

#    set(ENABLE_MODEL_PPT ON)
#    set(ENABLE_MODEL_POSTER ON)

    if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64|aarch64")
        set(ENABLE_ASSISTANT OFF)
        set(ENABLE_MCP OFF)
#    else()
#        set(ENABLE_MODEL_RPA ON)
    endif()
    message("SYSTEM PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} ${ENABLE_ASSISTANT}")
else()
    add_definitions(-DCOMPILE_ON_V20)
    set(COMPILE_ON_V20 TRUE)
    message("COMPILE ON v20")

    if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64|aarch64")
        set(ENABLE_ASSISTANT OFF)
        set(ENABLE_MCP OFF)
#    else()
#        set(ENABLE_MODEL_RPA ON)
    endif()
    if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
        set(COMPILE_ON_SW_20 TRUE)
    endif()
    message("SYSTEM PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} ${ENABLE_ASSISTANT}")
endif()

# Debug Or Release
if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-DEXTERNAL_LLM_DIR="${CMAKE_BINARY_DIR}/plugin-model")
    set(ENABLE_MODEL_PLUGINS ON)
else()
    add_definitions(-DEXTERNAL_LLM_DIR="${EXTERNAL_LLM_DIR}")
endif()

# Qt Version
if (${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    message("COMPILE ON QT6")
    add_definitions(-DCOMPILE_ON_QT6)
    set(DTK_VERSION_MAJOR 6)
else()
    message("COMPILE ON QT5")
    set(DTK_VERSION_MAJOR "")
endif()

if (ENABLE_MODEL_FYDN OR ENABLE_MODEL_PPT OR ENABLE_MODEL_POSTER OR ENABLE_MODEL_RPA OR ENABLE_MODEL_ZTBBD OR ENABLE_MODEL_XXZSK OR ENABLE_MODEL_YZSBS OR ENABLE_MODEL_TZDL)
    set(ENABLE_MODEL_PLUGINS ON)
endif()

if (ENABLE_AGENT_PLUGIN)
    add_definitions(-DENABLE_AGENT_PLUGIN)
    install(FILES ${PROJECT_SOURCE_DIR}/assets/agent/.readme DESTINATION share/uos-ai-assistant/agent)
endif()

if (ENABLE_MODEL_PLUGINS)
    add_definitions(-DENABLE_MODEL_PLUGIN)
endif()

if (ENABLE_ASSISTANT)
    add_definitions(-DENABLE_ASSISTANT)
endif()

if (ENABLE_PERSONAL_KNOWLEDGE_ASSISTANT)
    add_definitions(-DENABLE_PERSONAL_KNOWLEDGE_ASSISTANT)
endif()

if (ENABLE_MCP)
    add_definitions(-DENABLE_MCP)
endif()

if (ENABLE_AI_BAR)
    add_subdirectory(plugin-aibar)
    set(ENABLE_TRAY_PLUGIN OFF)
    add_definitions(-DENABLE_AI_BAR)
endif()

if (ENABLE_TRAY_PLUGIN)
    add_subdirectory(plugin-tray)
endif()

add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(ocr)
add_subdirectory(plugin-model)
add_subdirectory(plugin-fcitx)
add_subdirectory(plugin-settings)

# 安装帮助文档
install(DIRECTORY ${PROJECT_SOURCE_DIR}/docs/uos-ai-assistant
    DESTINATION share/deepin-manual/manual-assets/application)

=== 3rdparty/CMakeLists.txt ===
#tar -czvf qmarkdowntextedit.tar.gz ./qmarkdowntextedit
if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/qmarkdowntextedit")
    message("find qmarkdowntextedit")
else()
    message("decompression qmarkdowntextedit")
    execute_process(
        COMMAND tar -xzvf qmarkdowntextedit.tar.gz
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE QMARKDOWN_UNZIP_RESULT
    )

    if (NOT QMARKDOWN_UNZIP_RESULT EQUAL "0")
        message(FATAL_ERROR "tar qmarkdowntextedit.tar.gz failed: ${QMARKDOWN_UNZIP_RESULT}")
    endif()
endif()

add_subdirectory(qmarkdowntextedit)

=== ocr/CMakeLists.txt ===
project(uos-ai-ocr-process)

# 查找必要的包
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui)
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core Widget)

# 查找 OCR 包
find_package(PkgConfig REQUIRED)
pkg_check_modules(dtkocr REQUIRED dtk${DTK_VERSION_MAJOR}ocr)

# 源文件
set(OCR_SOURCES
    ocr_process.cpp
)

# 创建可执行文件
add_executable(${PROJECT_NAME} ${OCR_SOURCES})

# 包含目录
target_include_directories(${PROJECT_NAME} PRIVATE
    ${dtkocr_INCLUDE_DIRS}
)

# 链接库
target_link_libraries(${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    ${dtkocr_LIBRARIES}
)

# 安装可执行文件
install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/uos-ai-assistant)

=== plugin-fcitx/CMakeLists.txt ===
if (COMPILE_ON_V20)
    add_subdirectory(fcitx4)
elseif(COMPILE_ON_V23)
    add_subdirectory(fcitx5)
endif()

=== plugin-settings/CMakeLists.txt ===
project(uos-ai-settings)

#遍历所有文件
file(GLOB_RECURSE PLUGIN_SETTINGS_FILES plugin-settings/*.h plugin-settings/*.cpp plugin-settings/*.qrc)

# Install qm files
file(GLOB PLUGIN_SETTINGS_QMFILES "${CMAKE_SOURCE_DIR}/translations/uos-ai-settings*.qm")
install(FILES ${PLUGIN_SETTINGS_QMFILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/translations/)

=== src/CMakeLists.txt ===
project(uos-ai-assistant)

#遍历所有文件
file(GLOB_RECURSE EXE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.h ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp ${CMAKE_CURRENT_SOURCE_DIR}/*.qrc)

# 动态查找 Qt 包
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    DBus
    Concurrent
    Sql
    WebSockets
    Svg
    Multimedia
)

# Find the library
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core Widget )
find_package(X11 REQUIRED)
find_package(PkgConfig REQUIRED)

add_definitions(-DENABLE_FREEACCOUNT)

if (COMPILE_ON_V25)
    # Standard installation paths
    include(GNUInstallDirs)
    # Macros
    include(FeatureSummary)

    qt_standard_project_setup(REQUIRES 6.8)

    find_package(Qt6 REQUIRED COMPONENTS WaylandClient)
    find_package(TreelandProtocols REQUIRED)
    pkg_check_modules(WLR_PROTOCOLS REQUIRED IMPORTED_TARGET wlr-protocols)
    pkg_get_variable(WLR_PROTOCOLS_DATADIR wlr-protocols pkgdatadir)

elseif(COMPILE_ON_V20)
    find_package(Qt5 REQUIRED COMPONENTS WaylandClient)
    find_package(KF5Wayland REQUIRED)
endif()

pkg_check_modules(AtSpi REQUIRED atspi-2)
pkg_check_modules(Gobject REQUIRED gobject-2.0)
pkg_check_modules(Docparser REQUIRED IMPORTED_TARGET docparser)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(JWT REQUIRED libjwt)
pkg_check_modules(GIO_LIB REQUIRED
        gio-unix-2.0
        glib-2.0
)

if (COMPILE_ON_V25)
    pkg_check_modules(WL_PROTOCOLS REQUIRED IMPORTED_TARGET wayland-protocols)
    pkg_get_variable(WL_PROTOCOLS_DATADIR wayland-protocols pkgdatadir)
    add_executable(${PROJECT_NAME}
        ${EXE_FILES}
        ../treeland/ddeshellwayland.h
        ../treeland/ddeshellwayland.cpp
        ../treeland/datacontrolmanagerv1.h
        ../treeland/datacontrolmanagerv1.cpp
        ../treeland/treelandclipboard.h
        ../treeland/treelandclipboard.cpp
        ../treeland/treelandddeactivev1.h
        ../treeland/treelandddeactivev1.cpp
        ../treeland/treelandeventmonitor.h
        ../treeland/treelandeventmonitor.cpp
        ../layershell/dlayershellwindow.h
        ../layershell/dlayershellwindow.cpp
        ../layershell/qwaylandlayershellsurface_p.h
        ../layershell/qwaylandlayershellsurface.cpp
        ../layershell/qwaylandlayershellintegration_p.h
        ../layershell/qwaylandlayershellintegration.cpp
    )

    qt_generate_wayland_protocol_client_sources(${PROJECT_NAME}
        FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
        ${WLR_PROTOCOLS_DATADIR}/unstable/wlr-data-control-unstable-v1.xml
        ${WL_PROTOCOLS_DATADIR}/stable/xdg-shell/xdg-shell.xml
        ${CMAKE_SOURCE_DIR}/layershell/protocol/wlr-layer-shell-unstable-v1.xml
    )
elseif(COMPILE_ON_V20)
    add_executable(${PROJECT_NAME}
        ${EXE_FILES}
        ../wayland/waylandclipboard.h
        ../wayland/waylandclipboard.cpp
        ../wayland/waylandeventmonitor.h
        ../wayland/waylandeventmonitor.cpp
    )
else()
    add_executable(${PROJECT_NAME}
        ${EXE_FILES}
    )
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/agent
    ${CMAKE_CURRENT_SOURCE_DIR}/dbs
    ${CMAKE_CURRENT_SOURCE_DIR}/dbs/dbwrapper
    ${CMAKE_CURRENT_SOURCE_DIR}/dbs/tables
    ${CMAKE_CURRENT_SOURCE_DIR}/tables
    ${CMAKE_CURRENT_SOURCE_DIR}/dbus
    ${CMAKE_CURRENT_SOURCE_DIR}/gui/mgmt
    ${CMAKE_CURRENT_SOURCE_DIR}/gui/chat
    ${CMAKE_CURRENT_SOURCE_DIR}/gui/screen
    ${CMAKE_CURRENT_SOURCE_DIR}/http
    ${CMAKE_CURRENT_SOURCE_DIR}/llm
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/360
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/zhipu
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/openai
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/iflytek
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/baidu
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/localtext2image
    ${CMAKE_CURRENT_SOURCE_DIR}/llm/common
    ${CMAKE_CURRENT_SOURCE_DIR}/socket
    ${CMAKE_CURRENT_SOURCE_DIR}/wrapper
    ${CMAKE_CURRENT_SOURCE_DIR}/tas
    ${CMAKE_CURRENT_SOURCE_DIR}/utils
    ${CMAKE_CURRENT_SOURCE_DIR}/audio
    ${CMAKE_CURRENT_SOURCE_DIR}/audio/server
    ${CMAKE_CURRENT_SOURCE_DIR}/audio/trans
    ${CMAKE_CURRENT_SOURCE_DIR}/oscontrol
    ${CMAKE_CURRENT_SOURCE_DIR}/oscontrol/ability
    ${CMAKE_CURRENT_SOURCE_DIR}/tools
    ${CMAKE_CURRENT_SOURCE_DIR}/wordwizard
    ${CMAKE_CURRENT_SOURCE_DIR}/audiowizard
    ${AtSpi_INCLUDE_DIRS}
    ${Gobject_INCLUDE_DIRS}
    ${GIO_LIB_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/3rdparty/qmarkdowntextedit
)

if (COMPILE_ON_SW_20)
    pkg_check_modules(QTWEB REQUIRED Qt5WebEngineWidgets)
    target_include_directories(${PROJECT_NAME} PUBLIC ${QTWEB_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME} ${QTWEB_LIBRARIES})
else()
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS WebEngineWidgets)
    target_link_libraries(${PROJECT_NAME} Qt${QT_VERSION_MAJOR}::WebEngineWidgets)
endif()

# Include agent directory
include(${CMAKE_CURRENT_SOURCE_DIR}/agent/CMakeLists.txt)

if (COMPILE_ON_V25)
    target_include_directories(${PROJECT_NAME} PUBLIC
        ${CMAKE_SOURCE_DIR}/treeland
        ${CMAKE_SOURCE_DIR}/layershell
        ${CMAKE_SOURCE_DIR}/layershell/protocol
        )
elseif(COMPILE_ON_V20)
    target_include_directories(${PROJECT_NAME} PUBLIC
        ${CMAKE_SOURCE_DIR}/wayland
        )
endif()

target_link_libraries(${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::Sql
    Qt${QT_VERSION_MAJOR}::WebSockets
    Qt${QT_VERSION_MAJOR}::Svg
    Qt${QT_VERSION_MAJOR}::Multimedia

    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Widget

    ${AtSpi_LIBRARIES}
    ${Gobject_LIBRARIES}
    ${X11_LIBRARIES}
    ${XTST_LIBRARIES}
    crypto
    PkgConfig::Docparser
    ${GIO_LIB_LIBRARIES}
    qmarkdowntextedit
    ${JWT_LIBRARIES}
    pthread
)

if (COMPILE_ON_V25)
    target_link_libraries(${PROJECT_NAME}
        Qt6::WaylandClient
        Qt6::WaylandClientPrivate
    )
elseif(COMPILE_ON_V20)
    target_link_libraries(${PROJECT_NAME}
        Qt5::WaylandClient
        KF5::WaylandClient
        )
endif()

# Install bin
install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

# Install qm files
file(GLOB EXE_QM_FILES "${CMAKE_SOURCE_DIR}/translations/uos-ai-assistant*.qm")
install(FILES ${EXE_QM_FILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/translations/)

# Install service
file(GLOB SERVICE_FILES "${CMAKE_SOURCE_DIR}/assets/*.service")
install(FILES ${SERVICE_FILES} DESTINATION share/dbus-1/services)

# Install credits
file(GLOB CREDITS_FILES "${CMAKE_SOURCE_DIR}/assets/${PROJECT_NAME}.json")
install(FILES ${CREDITS_FILES} DESTINATION share/deepin/credits)

# Install functions
set(FUNCTIONS_DESTINATION "/usr/lib/${PROJECT_NAME}/functions")
add_definitions(-DFUNCTIONPATH="${FUNCTIONS_DESTINATION}")
file(GLOB FUNCTIONS_FILES "${CMAKE_SOURCE_DIR}/assets/functions/*")
install(FILES ${FUNCTIONS_FILES} DESTINATION ${FUNCTIONS_DESTINATION})

# Install audio
set(AUDIO_DESTINATION "/usr/lib/${PROJECT_NAME}/audio")
add_definitions(-DAUDIOPATH="${AUDIO_DESTINATION}")
file(GLOB AUDIO_FILES "${CMAKE_SOURCE_DIR}/assets/audio/*")
install(FILES ${AUDIO_FILES} DESTINATION ${AUDIO_DESTINATION})

# install desktop
install(FILES ${CMAKE_SOURCE_DIR}/assets/app/uos-ai-assistant.desktop
    DESTINATION share/applications)

# install context menu configuration
if (ENABLE_ASSISTANT)
install(FILES ${CMAKE_SOURCE_DIR}/assets/configs/uos-ai-knowledgebase.conf
    DESTINATION share/applications/context-menus)
endif()

# xdg-autostart
install(FILES ${CMAKE_SOURCE_DIR}/assets/autostart/uos-ai-assistant.autostart.desktop
    DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart)

# install tts.sh shortcut
file(GLOB TTS_SH "${CMAKE_SOURCE_DIR}/assets/shell/*.sh")
install(FILES ${TTS_SH}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/shell/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                    GROUP_READ GROUP_EXECUTE
                    WORLD_READ WORLD_EXECUTE)

install(FILES ${CMAKE_SOURCE_DIR}/assets/images/UosAiAssistantLogo.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)

include(${CMAKE_SOURCE_DIR}/install_dconfig.cmake)
INSTALL_DCONFIG("uos-ai-assistant.audiowizard.json")
INSTALL_DCONFIG("uos-ai-assistant.tts.json")
INSTALL_DCONFIG("uos-ai-assistant.wordwizard.json")
INSTALL_DCONFIG("uos-ai-assistant.aiquick.json")
INSTALL_DCONFIG("uos-ai-assistant.llm.json")

=== plugin-fcitx/fcitx4/CMakeLists.txt ===
project(fcitx-uosai)
find_package(Fcitx 4.2.8 REQUIRED)

_fcitx_add_uninstall_target()

pkg_check_modules(DBus "dbus-1" REQUIRED IMPORTED_TARGET)

set(CMAKE_AUTOMOC OFF)
set(CMAKE_AUTORCC OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories (
    ${PROJECT_BINARY_DIR}
    ${FCITX4_FCITX_UTILS_INCLUDE_DIRS}
    ${FCITX4_FCITX_CONFIG_INCLUDE_DIRS}
    ${FCITX4_FCITX_INCLUDE_DIRS}
    ${LIBINTL_INCLUDE_DIR}
    )

set(fcitx_uosai_sources
    eim.cpp
    config.cpp
    bus.cpp
    )

add_definitions( -DLOCALEDIR=\"${CMAKE_INSTALL_PREFIX}/share/locale\" )

configure_file(fcitx-uosai.desc fcitx-uosai.desc)

fcitx_add_addon_full(uosai DESC
SOURCES ${fcitx_uosai_sources}
IM_CONFIG uosaiplugin.conf
LINK_LIBS PkgConfig::DBus ${LIBINTL_LIBRARIES} X11 Xtst
)

configure_file(config.h.in config.h)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/fcitx)

file(GLOB PLUGIN_FCITX_CONFIGFILE "${CMAKE_BINARY_DIR}/plugin-fcitx/src/fcitx-uosai.conf")
install(FILES ${PLUGIN_FCITX_CONFIGFILE} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/fcitx/addon/)

file(GLOB PLUGIN_FCITX_DESCFILE "${CMAKE_BINARY_DIR}/plugin-fcitx/src/fcitx-uosai.desc")
install(FILES ${PLUGIN_FCITX_DESCFILE} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/fcitx/configdesc/)

=== plugin-fcitx/fcitx5/CMakeLists.txt ===
project(uosai)

set(CMAKE_AUTOMOC OFF)
set(CMAKE_AUTORCC OFF)

set(CMAKE_CXX_STANDARD 17)

find_package(Fcitx5Core REQUIRED)
find_package(Fcitx5Utils REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(DBUS REQUIRED dbus-1)

include_directories(${DBUS_INCLUDE_DIRS})
link_directories(${DBUS_LIBRARY_DIRS})

add_definitions(${DBUS_CFLAGS_OTHERS})

include_directories(/usr/include/Fcitx5/Core)
include_directories(/usr/include/Fcitx5/Utils)
include_directories(/usr/include/Fcitx5/Module)

add_library(${PROJECT_NAME} MODULE uosai.cpp)

target_link_libraries(${PROJECT_NAME}
    Fcitx5::Core
    Fcitx5::Utils
    ${DBUS_LIBRARIES}
)

# if (ENABLE_X11)
#     target_link_libraries(fcitx4frontend Fcitx5::Module::XCB XCB::XCB)
# endif()


configure_file(uosai.conf.in.in uosai.conf.in @ONLY)

fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/uosai.conf.in uosai.conf)

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/uosai.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon" COMPONENT config)

install(TARGETS uosai DESTINATION "${FCITX_INSTALL_ADDONDIR}")

=== plugin-model/poster/CMakeLists.txt ===
project(poster)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui WebSockets DBus)

FILE(GLOB_RECURSE SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(ASSETS_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/uos-ai-assistant/llm/${PROJECT_NAME}/assets/")
if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-DASSETS_INSTALL_DIR="${CMAKE_CURRENT_SOURCE_DIR}/assets/")
else()
    add_definitions(-DASSETS_INSTALL_DIR="${ASSETS_INSTALL_DIR}")
endif()

add_library(${PROJECT_NAME}
    SHARED
    ${SRCS}
    )

target_link_libraries(${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::WebSockets
    )

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)

if (ENABLE_MODEL_POSTER)
    message("install poster plugin...")
    install(TARGETS ${PROJECT_NAME} DESTINATION ${EXTERNAL_LLM_DIR})

    file(GLOB ASSET_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/icons/*")
    install(FILES ${ASSET_FILES} DESTINATION "${ASSETS_INSTALL_DIR}/icons")

    file(GLOB FAQ_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/*.json")
    install(FILES ${FAQ_FILES} DESTINATION ${ASSETS_INSTALL_DIR})

endif()

=== plugin-model/ppt/CMakeLists.txt ===
project(ppt)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui WebSockets DBus)

FILE(GLOB_RECURSE SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(ASSETS_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/uos-ai-assistant/llm/${PROJECT_NAME}/assets/")
if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-DASSETS_INSTALL_DIR="${CMAKE_CURRENT_SOURCE_DIR}/assets/")
else()
    add_definitions(-DASSETS_INSTALL_DIR="${ASSETS_INSTALL_DIR}")
endif()

add_library(${PROJECT_NAME}
    SHARED
    ${SRCS}
    )

target_link_libraries(${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::WebSockets
    )

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)

if (ENABLE_MODEL_PPT)
    message("install ppt plugin...")
    install(TARGETS ${PROJECT_NAME} DESTINATION ${EXTERNAL_LLM_DIR})

    file(GLOB ASSET_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/icons/*")
    install(FILES ${ASSET_FILES} DESTINATION "${ASSETS_INSTALL_DIR}/icons")

    file(GLOB FAQ_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/*.json")
    install(FILES ${FAQ_FILES} DESTINATION ${ASSETS_INSTALL_DIR})

endif()

=== plugin-model/rpa/CMakeLists.txt ===
project(rpa)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui)

FILE(GLOB_RECURSE SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(ASSETS_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/uos-ai-assistant/llm/${PROJECT_NAME}/assets/")
if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-DASSETS_INSTALL_DIR="${CMAKE_CURRENT_SOURCE_DIR}/assets/")
else()
    add_definitions(-DASSETS_INSTALL_DIR="${ASSETS_INSTALL_DIR}")
endif()

add_library(${PROJECT_NAME}
    SHARED
    ${SRCS}
    )

target_link_libraries(${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Gui
    )

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)

if (ENABLE_MODEL_RPA)
    message("install rpa plugin...")
    install(TARGETS ${PROJECT_NAME} DESTINATION ${EXTERNAL_LLM_DIR})

    file(GLOB ASSET_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/icons/*")
    install(FILES ${ASSET_FILES} DESTINATION "${ASSETS_INSTALL_DIR}/icons")

    file(GLOB FAQ_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/*.json")
    install(FILES ${FAQ_FILES} DESTINATION ${ASSETS_INSTALL_DIR})

    file(GLOB FUNC_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/functions/*.json")
    install(FILES ${FUNC_FILES} DESTINATION ${ASSETS_INSTALL_DIR})

endif()

=== plugin-model/xxzsk/CMakeLists.txt ===
project(xxzsk)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui Network)

FILE(GLOB_RECURSE SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(ASSETS_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/uos-ai-assistant/llm/${PROJECT_NAME}/assets/")
if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-DASSETS_INSTALL_DIR="${CMAKE_CURRENT_SOURCE_DIR}/assets/")
else()
    add_definitions(-DASSETS_INSTALL_DIR="${ASSETS_INSTALL_DIR}")
endif()

add_library(${PROJECT_NAME}
    SHARED
    ${SRCS}
    )

target_link_libraries(${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Network
    )

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../)

include_directories(${CMAKE_SOURCE_DIR}/src)

if (ENABLE_MODEL_XXZSK)
    message("install xxzsk plugin...")
    install(TARGETS ${PROJECT_NAME} DESTINATION ${EXTERNAL_LLM_DIR})

    file(GLOB ASSET_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/icons/*")
    install(FILES ${ASSET_FILES} DESTINATION "${ASSETS_INSTALL_DIR}/icons")

    file(GLOB FAQ_FILES "${CMAKE_CURRENT_SOURCE_DIR}/assets/*.json")
    install(FILES ${FAQ_FILES} DESTINATION ${ASSETS_INSTALL_DIR})

endif()

=== debian/changelog ===
uos-ai (2.11.501-1) unstable; urgency=medium

  * update

 -- deepin <packages@deepin.com>  Sun, 28 Sep 2025 17:29:11 +0800

=== debian/control ===
Source: uos-ai
Section: non-free/copilot
Priority: optional
Maintainer: deepin <packages@deepin.com>
Build-Depends:
 debhelper (>= 9),
 cmake,
 pkg-config,
 libatspi2.0-dev,
 libdocparser-dev,
 libjwt-dev,
 libssl-dev,
 libfcitx5core-dev,
 libfcitx5utils-dev,
 fcitx5-modules-dev,
 qt6-base-dev,
 qt6-webengine-dev,
 qt6-websockets-dev,
 qt6-svg-dev,
 qt6-multimedia-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 qt6-wayland-dev,
 qt6-base-private-dev,
 qt6-wayland-private-dev,
 libdtk6widget-dev (>= 6.0.24),
 libdtk6declarative-dev (>= 6.0.19),
 libdde-shell-dev (>= 0.0.10),
 treeland-protocols (>= 0.4.4),
 wlr-protocols,
 wayland-protocols,
 libdtk6ocr-dev

Standards-Version: 4.5.0
Package: uos-ai
Architecture: any
Depends:
 ${shlibs:Depends},${misc:Depends},libqt6webenginecore6-bin
Description: As a useful and efficient assistant, an AI-powered assistant simplifies our office efficiency and provides valuable support in a wide range of domains.

Package: uos-ai-model-plugin
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 uos-ai
Description: Model plugins for UOS AI assistant
 This package contains various model plugins for UOS AI assistant,
 including different AI model implementations and configurations.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
export DH_VERBOSE = 1
include /usr/share/dpkg/default.mk

export QT_SELECT := 5

override_dh_auto_configure:
	dh_auto_configure -- -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) DEFINES+="VERSION=$(DEB_VERSION_UPSTREAM)" LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DBUILD_OS_VERSION=$(BUILD_OS_VERSION) -DENABLE_MODEL_FYDN=${ENABLE_MODEL_FYDN}

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_install:
	# 创建model-plugin包的安装目录
	mkdir -p debian/uos-ai-model-plugin/usr/share/uos-ai-assistant/llm
	mkdir -p debian/uos-ai-model-plugin/usr/lib

	# 移动llm目录下的所有文件到model-plugin包
	mv debian/tmp/usr/share/uos-ai-assistant/llm/* debian/uos-ai-model-plugin/usr/share/uos-ai-assistant/llm/ 2>/dev/null || true

	# 移动所有架构目录下的llm相关so文件到model-plugin包
	for arch_dir in debian/tmp/usr/lib/*; do \
		if [ -d "$$arch_dir/uos-ai-assistant/llm" ]; then \
			mkdir -p debian/uos-ai-model-plugin/usr/lib/$$(basename $$arch_dir)/uos-ai-assistant/llm; \
			mv $$arch_dir/uos-ai-assistant/llm/*.so debian/uos-ai-model-plugin/usr/lib/$$(basename $$arch_dir)/uos-ai-assistant/llm/ 2>/dev/null || true; \
		fi \
	done

	# 将剩余文件移动到uos-ai包
	mv debian/tmp/* debian/uos-ai/ 2>/dev/null || true

	dh_install

%:
	dh $@ --parallel

## uos-ai 2.12.511

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,16 +8,11 @@
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 
-# 增加安全编译参数
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -fPIC")
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all -fPIC")
-set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
-
 # generate qm files
 if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
     execute_process(COMMAND bash "${CMAKE_SOURCE_DIR}/translate_generation.sh" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
-endif ()
+endif()
 
 # 库目录
 set(LIB_PLATFORM_DIR "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}")
@@ -70,6 +65,14 @@
 option(ENABLE_MODEL_XXZSK "Enable XXZSK Plugin" OFF)
 option(ENABLE_MODEL_YZSBS "Enable YZSBS Plugin" OFF)
 option(ENABLE_MODEL_TZDL "Enable TZDL Plugin" OFF)
+
+if (NOT ${BUILD_OS_VERSION} MATCHES "25")
+    # 增加安全编译参数
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -fPIC")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all -fPIC")
+    set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
+    message("20 applying security hardening options")
+endif()
 
 # 系统判断
 if (${BUILD_OS_VERSION} MATCHES "25")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -253,3 +253,4 @@
 INSTALL_DCONFIG("uos-ai-assistant.wordwizard.json")
 INSTALL_DCONFIG("uos-ai-assistant.aiquick.json")
 INSTALL_DCONFIG("uos-ai-assistant.llm.json")
+INSTALL_DCONFIG("uos-ai-assistant.mcp.json")

=== debian/changelog ===
uos-ai (2.12.511-1) unstable; urgency=medium

  * update

 -- deepin <packages@deepin.com>  Thu, 27 Nov 2025 21:11:28 +0800

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,15 @@
 include /usr/share/dpkg/default.mk
 
 export QT_SELECT := 5
+
+# 检查 BUILD_OS_VERSION 是否为 25
+ifneq (,$(filter 25,$(BUILD_OS_VERSION)))
+$(info BUILD_OS_VERSION is 25, applying security hardening options)
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -Wall -Wl,-E
+export DEB_CXXFLAGS_MAINT_APPEND = -Wall -Wl,-E
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack
+endif
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) DEFINES+="VERSION=$(DEB_VERSION_UPSTREAM)" LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
